<template>
  <div>
    <el-dialog
      width="50%"
      :visible="showHoneyLogsDialog"
      append-to-body
      @close="$emit('update:showHoneyLogsDialog', false)"
    >
      <!-- Start table honey logs -->
      <h2>Honey Logs</h2>
      <el-table
        height="400"
        v-loading="postLoading"
        empty-text="No data"
        :data="logs"
        style="width: 100%"
      >

        <el-table-column
          fixed
          min-width="100"
          prop="honey_delta"
          label="Honey"
        >
          <template slot-scope="scope">
            <div>
              <span
                v-if="scope.row.honey_delta > 0"
                class="honey-increase"
              >+{{scope.row.honey_delta}}</span>
              <span
                v-if="scope.row.honey_delta < 0"
                class="honey-decrease"
              >{{scope.row.honey_delta}}</span>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          min-width="150"
          prop="type"
          label="Type"
        >
          <template slot-scope="scope">
            <span> {{$helper.replaceUnderscore(scope.row.type)}}</span>
          </template>

        </el-table-column>

        <el-table-column
          prop="type"
          label="Extra"
        >
          <template slot-scope="scope">
            <div v-if="scope.row.type == 'create_job_post'">
              <span>Post a job in {{$helper.replaceUnderscore(scope.row.extra.product.key)}} </span>
            </div>
            <div v-else-if="scope.row.type == 'extend_job_post'">
              <span>Extend a job in {{$helper.replaceUnderscore(scope.row.extra.product.key)}} </span>
            </div>
            <div v-else-if="scope.row.type == 'admin_honey_changing'">
              <span>{{$helper.replaceUnderscore(scope.row.extra.admin.name)}} </span>
            </div>
            <div v-else-if="scope.row.type == 'seeker_premium'">
              <span v-if="scope.row.extra && scope.row.extra.product">Buy premium in
                {{scope.row.extra.product.duration}} day(s)
              </span>
            </div>
            <div v-else-if="scope.row.type == 'appstore_purchase'">
              <span v-if="scope.row.extra && scope.row.extra.purchase">
                Transaction ID: {{scope.row.extra.purchase.transaction_id}}
              </span>
            </div>
            <div v-else-if="scope.row.type == 'playstore_purchase'">
              <span v-if="scope.row.extra && scope.row.extra.purchase">
                Order: {{scope.row.extra.purchase.order_id}}
              </span>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          prop="created_at"
          label="Time"
        >
          <template slot-scope="scope">
            <div>
              <span>{{scope.row.created_at | moment('DD-MM-YYYY, HH:mm:ss ')}} </span>
            </div>
          </template>
        </el-table-column>
      </el-table>
      <!-- End table honey logs -->

      <el-pagination
        v-if="total > pageSize"
        class="right"
        background
        layout="prev, pager, next"
        style="margin-top: 20px"
        :current-page="currentPage"
        :page-size="pageSize"
        @current-change="onChangePage"
        :total="total"
      ></el-pagination>
    </el-dialog>
  </div>
</template>
<script>
import { honeylogs as honeylogsAPI } from '~/services/apis/index'
export default {
  props: ['showHoneyLogsDialog', 'userID'],
  data () {
    return {
      postLoading: false,
      logs: [],
      currentPage: 1,
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      defaultFilter: {},
      sortBy: "",
      dir: "",
    };
  },
  methods: {

    getHoneyLogs () {
      this.postLoading = true
      honeylogsAPI.getHoneyLogs(this.currentPage, 10, 'id', 'desc', this.userID)
        .then((res) => {
          this.logs = [...res.data.data];
          this.total = parseInt(res.headers["x-total-count"]);
          this.postLoading = false;
        });
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page);
      let sQuery = this.$route.query;
      sQuery.page = this.currentPage;
      this.getHoneyLogs(sQuery);
    },


  },
  mounted () {
    /*Call APIs when mounted*/
    this.getHoneyLogs()

  },
  watch: {

    showHoneyLogsDialog: function () {
      this.logs = this.getHoneyLogs()
    }

  },

}
</script>

<style lang="scss">
.upload-img-outer {
  position: relative;
  .icon-img-close {
    position: absolute;
    top: 3px;
    right: 5px;
    padding: 3px;

    &:hover {
    }
  }
}
.honey-increase {
  color: green;
}
.honey-decrease {
  color: red;
}
</style>
